\documentclass[11pt,a4paper]{article}

\usepackage{fullpage, amssymb, amsthm, enumerate, amsmath, pictexwd, mathrsfs, ../yomcat, ../diagrams}

\setlength{\arraycolsep}{2pt}
\setlength{\parskip}{1ex}
\setlength{\parindent}{0pt}

\newtheorem{prop}{Proposition}
\newtheorem{lemma}[prop]{Lemma}
\newtheorem{thm}[prop]{Theorem}
\newtheorem{cor}[prop]{Corollary}

\begin{document}

\part*{The Tutte Polynomial and Linear Codes}

\section*{Linear Codes}
A \mbf{linear code} over $GF(q)$ is a $k$-dimensional subspace of the vectorspace $GF(q)^n$. We call $k$ the \mbf{dimension} of the code and $n$ the \mbf{length} of the code. Codes are normally denoted $C$.

A linear code of length $n$ and dimension $k$ is called a $[n,k]$-code.

If $G$ is a $r \times n$ matrix over $GF(q)$, whose rows form a basis for $C$, then $G$ is a \mbf{generator matrix} for $C$. As with every matrix, there is an associated matroid, which in this case depends only on $C$. Hence the matroid is $M(C)$.

The \mbf{dual code}, $C^*$, of $C$, is defined by $C^* = \set{\mbf{v} \in GF(q)^n|\mbf{v} \cdot \mbf{w} = 0\ \forall \mbf{w} \in C}$. If $C$ is a $[n,k]$-code, then $C^*$ is a $[n, n-k]$-code. Furthermore, $M(C^*) \cong M^*(C)$ [White (1986)]

The members of a linear code are called \mbf{codewords}. If \mbf{v} is the codeword $(\vect{v}{n})$, then the \mbf{weight} of \mbf{v} is $w(\mbf{v}) = |\set{i|v_i \neq 0}|$.

The \mbf{distance} of $C$, denoted $d(C)$, is $\displaystyle\inf_{\mbf{v} \in C - 0}\set{w(\mbf{v})}$. It should be obvious that $d$ is the size of a smallest bond in $M(C)$, or the size of a smallest circuit in $M^*(C)$.


\section*{The Codeweight Polynomial}
If $W$ is a subspace of $GF(q)^n$, then $W_0$ will denote the subspace consisting of those vectors in $W$ whose first entry is 0. $\widehat{W}$ will denote the vectorspace obtained from $W$ by removing the first entry of every vector. By convention, $\widehat{W_0} = \widehat{W}$ where $W = W_0$.

For a linear code $C$, the \mbf{codeweight polynomial} $A(C; q, z)$ of $C$ is defined by \begin{align*}
	A(C; q, z) &= \sum_{\mbf{v} \in C} z^{w(\mbf{v})} \\
	\intertext{Thus, if $a_i$ is the number of codewords in $C$ having weight $i$, then}
	A(C; q, z) &= \sum_{i = 0}^n a_iz^i.
\end{align*}

\begin{thm}[Greene, 1976]
\[A(C; q, z) = (1-z)^kz^{n-k}T\left(M(C); \frac{1 + z(q-1)}{1-z}, \frac{1}{z}\right).\]
\end{thm}
\begin{proof}
Let $f(M(C)) = A(C; q, z)$. We will show that $f$ is well defined and that it is a TG-invariant, for which $a = z$ and $b = 1 - z$. Firstly, $f$ is well defined if $C$ has length 1, as then
\[
	f(M(C)) = \begin{cases}
		1, & \text{if $M(C)$ is a loop,} \\
		1 + z(q-1), & \text{if $M(C)$ is a coloop.}
	\end{cases}
\]
Assume that $f$ is well-defined if $C$ has length strictly less than $m$, and suppose that $C$ has length $m$, where $m \geq 2$.

Let $G$ be a generator matrix for $C$ and suppose that $e \in M(C)$ is not a loop or a coloop. WOLOG, we may assume that $e$ corresponds to the first column of $G$. Let $G'$ be the matrix obtained by applying standard row operations to $G$ so that $G'_{1,1} = 1$ and $G'_{i,1} = 0$, for all $i \neq 1$. Clearly, $G'$ is also a generator matrix for $C$. From the matrix $G'$, we can deduce that \begin{align}
	M(\widehat{C_0}) = M(C)\contract e \qquad\text{and}\qquad M(\widehat{C}) = M(C)\delete e
\end{align}
Now consider the map $g: C - C_0 \rTo \widehat{C} - \widehat{C_0}$.
\end{proof}
\end{document}